const { sendMatrixEvent } = require('../../../matrix-bot');
const { validatePost } = require('../utils');
const evaluateMatrixPoolOutcome = require('./evaluate');

const initiateMatrixPool = async (postId, post, sender, fee) => {
  const duration = 20;
  const quorum = [1, 3];
  const winRatio = [1, 2];
  const params = {
    sender,
    fee: Number(fee),
    duration,
    quorum,
    winRatio,
  };

  console.log('sending matrix pool start event');
  const { roomId, eventId } = await sendMatrixEvent('io.dgov.pool.start', {
    postId,
    ...params,
  });
  console.log('sent matrix pool start event');
  // Register our own stake and send a message
  await validatePost({
    sender, post, postId, roomId, eventId, ...params,
  });

  // Since we're assuming responsibility as the batch worker,
  // set a timeout to evaulate the outcome
  setTimeout(
    () => {
      evaluateMatrixPoolOutcome(postId);
    },
    duration * 1000,
  );
};

module.exports = {
  initiateMatrixPool,
};
